#ifndef CALLBACK_HPP
#define CALLBACK_HPP

///////////////////////////////////////////////////////////////////////////////
//
// $Header: $
//
// NAME: Callback
//
// BASE CLASSES: None.
//
// PURPOSE: Graphical User Interface callback functions.
//
// AUTHOR: Brice DONVAL
//
//  COPYRIGHT NOTICE:
//
// The KOYOTE Project
// Copyright (C) 2003-2004 Nicolas MOREAU & Brice DONVAL
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  REVISION HISTORY:
// $Log: $
//
///////////////////////////////////////////////////////////////////////////////

//Includes

#include <gtk/gtk.h>
#include <cstdlib>

//Constants

/* Widgets */
extern GtkWidget* pWindow;
extern GtkWidget* pLabel;
extern GtkWidget* pDrawingArea;
extern GtkTextBuffer* pErr;
extern GdkPixmap* pPixmap;

//Types and classes

class Callback
{
public:
  static void OnLoad(void);
  static void OnNext(void);
  static void OnReset(void);
  static void OnError(void); // DEPRECATED
  static void OnQuit(void);
  //static void OnDestroy(void); // OBSOLETE
  static void OnAbout(void);
  static gint ExposeEvent(GtkWidget*,GdkEventExpose*);
  static gint ConfigureEvent(GtkWidget*,GdkEventConfigure*);
  static gint MotionNotifyEvent(GtkWidget*,GdkEventMotion*); // DEPRECATED
  static gint ButtonPressEvent(GtkWidget*,GdkEventButton*);
};

#endif // CALLBACK_HPP
