#ifndef REGISTERBOX_HPP
#define REGISTERBOX_HPP

///////////////////////////////////////////////////////////////////////////////
//
// $Header: $
//
// NAME: RegisterBox
//
// BASE CLASSES: DataPathComponent.
//
// PURPOSE: This class describes a simple RegisterBox object.
//
// AUTHOR: Nicolas MOREAU & Brice DONVAL
//
//  COPYRIGHT NOTICE:
//
// The KOYOTE Project
// Copyright (C) 2003-2004 Nicolas MOREAU & Brice DONVAL
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  REVISION HISTORY:
// $Log: $
//
///////////////////////////////////////////////////////////////////////////////

//Includes

#include "../Core/Registers.hpp"
#include "DataPathComponent.hpp"

//Constants

//Constants

//Types and classes

class RegisterBox : public DataPathComponent
{
public:
  RegisterBox(Coordinate*,
	      const int,
	      const DisplayMode);
  ~RegisterBox(void);
  word GetValue(const int,
		const AskMode);
  void Reset(void);
  void Display(void);
  void MouseAction(const MouseEvent);
protected:
  word* m_pwRegister;
};

#endif // REGISTERBOX_HPP
