#ifndef CORE_HPP
#define CORE_HPP

///////////////////////////////////////////////////////////////////////////////
//
// $Header: $
//
// NAME: Core
//
// BASE CLASSES: None.
//
// PURPOSE: Core functions.
//
// AUTHOR: Nicolas MOREAU
//
//  COPYRIGHT NOTICE:
//
// The KOYOTE Project
// Copyright (C) 2003-2004 Nicolas MOREAU & Brice DONVAL
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  REVISION HISTORY:
// $Log: $
//
///////////////////////////////////////////////////////////////////////////////

//Includes

//Types

typedef unsigned char byte;
typedef unsigned long word;

//Constants
extern word START_ADDR;
extern word END_ADDR;

//Classes

class Core
{
public:
  static byte Bit(word,byte);
  static word Sel(word,byte,byte);
  static word Sub(word,byte,byte);
  static word Mux(word,word,byte);
  static word Mux(word,word,word,byte);
  static word Mux(word,word,word,word,byte);
  static word Mux(word,word,word,word,word,word,word,word,byte);
  static word Ext(word);
};
#endif // CORE_HPP
