#ifndef MEMORY_HPP
#define MEMORY_HPP

///////////////////////////////////////////////////////////////////////////////
//
// $Header: $
//
// NAME: Memory
//
// BASE CLASSES: None.
//
// PURPOSE: This file describes the MIPS Memory.
//
// AUTHOR: Nicolas MOREAU
//
//  COPYRIGHT NOTICE:
//
// The KOYOTE Project
// Copyright (C) 2003-2004 Nicolas MOREAU & Brice DONVAL
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  REVISION HISTORY:
// $Log: $
//
///////////////////////////////////////////////////////////////////////////////

//Includes

#include "AllocTable.hpp"

//Constants

//Types and classes

class Memory
{
public:
  Memory(void);
  ~Memory(void);
  void Init(AllocTable*);
  AllocTable* GetAllocTable(void);
  void Reset(void);
  word& operator[](word);
private:
  AllocTable* m_pAllocTable;
};

#endif // MEMORY_HPP
