#ifndef REGISTERS_HPP
#define REGISTERS_HPP

///////////////////////////////////////////////////////////////////////////////
//
// $Header: $
//
// NAME: Registers
//
// BASE CLASSES: None.
//
// PURPOSE: This file describes the MIPS Registers.
//
// AUTHOR: Nicolas MOREAU
//
//  COPYRIGHT NOTICE:
//
// The KOYOTE Project
// Copyright (C) 2003-2004 Nicolas MOREAU & Brice DONVAL
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  REVISION HISTORY:
// $Log: $
//
///////////////////////////////////////////////////////////////////////////////

//Includes

//Constants

#define MAX_REGISTERS  32

// This array is used to match a number with the corresponding register's name
// It is defined in 'Registers.cpp'
extern const char *szRegister[MAX_REGISTERS];

//Types and classes

// This enum describes the 32 MIPS general registers
typedef enum { r0 = 0  ,  at = 1  , v0 = 2  , v1 = 3  ,
	       a0 = 4  ,  a1 = 5  , a2 = 6  , a3 = 7  ,
	       t0 = 8  ,  t1 = 9  , t2 = 10 , t3 = 11 ,
	       t4 = 12 ,  t5 = 13 , t6 = 14 , t7 = 15 ,
	       s0 = 16 ,  s1 = 17 , s2 = 18 , s3 = 19 ,
	       s4 = 20 ,  s5 = 21 , s6 = 22 , s7 = 23 ,
	       t8 = 24 ,  t9 = 25 , k0 = 26 , k1 = 27 ,
	       gp = 28 ,  sp = 29 , s8 = 30 , ra = 31 } REGISTER;

#endif // REGISTERS_HPP
