#ifndef DATAPATH_HPP
#define DATAPATH_HPP

///////////////////////////////////////////////////////////////////////////////
//
// $Header: $
//
// NAME: DataPath
//
// BASE CLASSES: None.
//
// PURPOSE: This generic class describes a simple datapath.
//
// AUTHOR: Nicolas MOREAU
//
//  COPYRIGHT NOTICE:
//
// The KOYOTE Project
// Copyright (C) 2003-2004 Nicolas MOREAU & Brice DONVAL
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  REVISION HISTORY:
// $Log: $
//
///////////////////////////////////////////////////////////////////////////////

//Includes

#include "../Components/DataPathComponent.hpp"

#include "../Core/Memory.hpp"

//Constants

//Types and classes

class DataPath
{
public:
  DataPath(DisplayMode);
  virtual ~DataPath(void);
  virtual word Cycle(void)=0;
  virtual void Display(void);
  virtual void Reset(void);
  virtual void Init(AllocTable*,AllocTable*)=0;
  virtual void MouseAction(Coordinate*,const MouseEvent);
protected:
  DisplayMode m_eDisplayMode;
  DataPathComponent** m_ppComponent;
  Coordinate** m_ppCoord;
  int m_nComponent;
  DataPathComponent* m_pStart;
};

#endif // DATAPATH_HPP
