#ifndef MONOCYCLEDATAPATH_HPP
#define MONOCYCLEDATAPATH_HPP

///////////////////////////////////////////////////////////////////////////////
//
// $Header: $
//
// NAME: MonocycleDataPath
//
// BASE CLASSES: DataPath.
//
// PURPOSE: This class describes a simple monocycle datapath.
//
// AUTHOR: Nicolas MOREAU
//
//  COPYRIGHT NOTICE:
//
// The KOYOTE Project
// Copyright (C) 2003-2004 Nicolas MOREAU & Brice DONVAL
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//  REVISION HISTORY:
// $Log: $
//
///////////////////////////////////////////////////////////////////////////////

//Includes

#include "../DataPath.hpp"

#include "../../Components/Adder.hpp"
#include "../../Components/ALU.hpp"
#include "../../Components/Comparator.hpp"
#include "../../Components/Constant.hpp"
#include "../../Components/GateAND.hpp"
#include "../../Components/GateNOT.hpp"
#include "../../Components/GateOR.hpp"
#include "../../Components/LightShifter.hpp"
#include "../../Components/Multiplexor.hpp"
#include "../../Components/RegisterBox.hpp"
#include "../../Components/Shifter.hpp"
#include "../../Components/SignExtender.hpp"
#include "../../Components/Wire.hpp"

#include "../../Components/Monocycle/ControlUnit.hpp"
#include "../../Components/Monocycle/DataMemory.hpp"
#include "../../Components/Monocycle/InstructionMemory.hpp"
#include "../../Components/Monocycle/ProgramCounter.hpp"

//Constants

//Types and classes

class MonocycleDataPath : public DataPath
{
public:
  MonocycleDataPath(DisplayMode);
  ~MonocycleDataPath(void);
  word Cycle(void);
  void Init(AllocTable*,AllocTable*);
};

#endif // MONOCYCLEDATAPATH_HPP
